Index: thirdparty/pom.xml
===================================================================
--- thirdparty/pom.xml	(revision 99325)
+++ thirdparty/pom.xml	(working copy)
@@ -844,6 +844,41 @@
                 <componentId>hibernate</componentId>
               </mapping>
             </dependency>
+			<dependency>
+              <groupId>org.hibernate</groupId>
+              <artifactId>hibernate-ehcache</artifactId>
+              <mapping>
+                <componentId>hibernate</componentId>
+              </mapping>
+            </dependency>
+			<dependency>
+              <groupId>org.hibernate</groupId>
+              <artifactId>hibernate-oscache</artifactId>
+              <mapping>
+                <componentId>hibernate</componentId>
+              </mapping>
+            </dependency>
+			<dependency>
+              <groupId>org.hibernate</groupId>
+              <artifactId>hibernate-swarmcache</artifactId>
+              <mapping>
+                <componentId>hibernate</componentId>
+              </mapping>
+            </dependency>
+			<dependency>
+              <groupId>org.hibernate</groupId>
+              <artifactId>hibernate-c3p0</artifactId>
+              <mapping>
+                <componentId>hibernate</componentId>
+              </mapping>
+            </dependency>
+			<dependency>
+              <groupId>org.hibernate</groupId>
+              <artifactId>hibernate-proxool</artifactId>
+              <mapping>
+                <componentId>hibernate</componentId>
+              </mapping>
+            </dependency>
             <dependency>
               <groupId>org.hibernate</groupId>
               <artifactId>hibernate-annotations</artifactId>
@@ -1220,6 +1255,26 @@
     </dependency>
     <dependency>
       <groupId>org.hibernate</groupId>
+      <artifactId>hibernate-ehcache</artifactId>
+    </dependency>
+    <dependency>
+      <groupId>org.hibernate</groupId>
+      <artifactId>hibernate-oscache</artifactId>
+    </dependency>
+    <dependency>
+      <groupId>org.hibernate</groupId>
+      <artifactId>hibernate-swarmcache</artifactId>
+    </dependency>
+    <dependency>
+      <groupId>org.hibernate</groupId>
+      <artifactId>hibernate-c3p0</artifactId>
+    </dependency>
+    <dependency>
+      <groupId>org.hibernate</groupId>
+      <artifactId>hibernate-proxool</artifactId>
+    </dependency>
+    <dependency>
+      <groupId>org.hibernate</groupId>
       <artifactId>hibernate-annotations</artifactId>
     </dependency>
     <dependency>
Index: component-matrix/pom.xml
===================================================================
--- component-matrix/pom.xml	(revision 99325)
+++ component-matrix/pom.xml	(working copy)
@@ -1118,6 +1118,106 @@
 
       <dependency>
         <groupId>org.hibernate</groupId>
+        <artifactId>hibernate-ehcache</artifactId>
+        <version>${version.org.hibernate}</version>
+        <exclusions>
+          <exclusion>
+            <groupId>org.slf4j</groupId>
+            <artifactId>slf4j-api</artifactId>
+          </exclusion>
+          <exclusion>
+            <groupId>org.slf4j</groupId>
+            <artifactId>slf4j-log4j12</artifactId>
+          </exclusion>
+		  <exclusion>
+			<groupId>net.sf.ehcache</groupId>
+			<artifactId>ehcache</artifactId>
+		  </exclusion>
+        </exclusions>
+      </dependency>
+
+      <dependency>
+        <groupId>org.hibernate</groupId>
+        <artifactId>hibernate-oscache</artifactId>
+        <version>${version.org.hibernate}</version>
+        <exclusions>
+          <exclusion>
+            <groupId>org.slf4j</groupId>
+            <artifactId>slf4j-api</artifactId>
+          </exclusion>
+          <exclusion>
+            <groupId>org.slf4j</groupId>
+            <artifactId>slf4j-log4j12</artifactId>
+          </exclusion>
+		  <exclusion>
+			<groupId>opensymphony</groupId>
+			<artifactId>oscache</artifactId>
+		  </exclusion>
+        </exclusions>
+      </dependency>
+
+      <dependency>
+        <groupId>org.hibernate</groupId>
+        <artifactId>hibernate-swarmcache</artifactId>
+        <version>${version.org.hibernate}</version>
+        <exclusions>
+          <exclusion>
+            <groupId>org.slf4j</groupId>
+            <artifactId>slf4j-api</artifactId>
+          </exclusion>
+          <exclusion>
+            <groupId>org.slf4j</groupId>
+            <artifactId>slf4j-log4j12</artifactId>
+          </exclusion>
+		  <exclusion>
+			<groupId>swarmcache</groupId>
+			<artifactId>swarmcache</artifactId>
+		  </exclusion>
+        </exclusions>
+      </dependency>
+
+      <dependency>
+        <groupId>org.hibernate</groupId>
+        <artifactId>hibernate-c3p0</artifactId>
+        <version>${version.org.hibernate}</version>
+        <exclusions>
+          <exclusion>
+            <groupId>org.slf4j</groupId>
+            <artifactId>slf4j-api</artifactId>
+          </exclusion>
+          <exclusion>
+            <groupId>org.slf4j</groupId>
+            <artifactId>slf4j-log4j12</artifactId>
+          </exclusion>
+		  <exclusion>
+			<groupId>c3p0</groupId>
+			<artifactId>c3p0</artifactId>
+		  </exclusion>
+        </exclusions>
+      </dependency>
+
+      <dependency>
+        <groupId>org.hibernate</groupId>
+        <artifactId>hibernate-proxool</artifactId>
+        <version>${version.org.hibernate}</version>
+        <exclusions>
+          <exclusion>
+            <groupId>org.slf4j</groupId>
+            <artifactId>slf4j-api</artifactId>
+          </exclusion>
+          <exclusion>
+            <groupId>org.slf4j</groupId>
+            <artifactId>slf4j-log4j12</artifactId>
+          </exclusion>
+		  <exclusion>
+			<groupId>proxool</groupId>
+			<artifactId>proxool</artifactId>
+		  </exclusion>
+        </exclusions>
+      </dependency>
+
+      <dependency>
+        <groupId>org.hibernate</groupId>
         <artifactId>hibernate-jbosscache2</artifactId>
         <version>${version.org.hibernate}</version>
         <exclusions>
Index: testsuite/build.xml
===================================================================
--- testsuite/build.xml	(revision 99325)
+++ testsuite/build.xml	(working copy)
@@ -372,6 +372,11 @@
       <!-- path refid="hibernate3.classpath"/ -->
       <pathelement path="${jboss.dist.common.lib}/hibernate-core.jar" />
       <pathelement path="${jboss.dist.common.lib}/hibernate-jmx.jar" />
+	  <pathelement path="${jboss.dist.common.lib}/hibernate-ehcache.jar" />
+      <pathelement path="${jboss.dist.common.lib}/hibernate-oscache.jar" />
+      <pathelement path="${jboss.dist.common.lib}/hibernate-swarmcache.jar" />
+      <pathelement path="${jboss.dist.common.lib}/hibernate-c3p0.jar" />
+      <pathelement path="${jboss.dist.common.lib}/hibernate-proxool.jar" />
       <!-- path refid="odmg.classpath"/ -->
       <pathelement path="${odmg.odmg.lib}/odmg-3.0.jar" />
       <!-- path refid="cglib.classpath"/ -->
Index: build/build.xml
===================================================================
--- build/build.xml	(revision 99325)
+++ build/build.xml	(working copy)
@@ -852,6 +852,9 @@
     <move todir="${install.common.lib}">
       <fileset dir="${install.all.lib}">
         <exclude name="hibernate-jbosscache2.jar"/>
+		<exclude name="hibernate-ehcache.jar"/>
+		<exclude name="hibernate-oscache.jar"/>
+		<exclude name="hibernate-swarmcache.jar"/>
         <exclude name="jacorb.jar"/>
         <exclude name="jbosscache-core.jar"/>
         <exclude name="jbosscache-pojo.jar"/>
@@ -1046,6 +1049,9 @@
         <include name="deploy/cluster/jboss-cache-manager.sar/**"/>
         <include name="lib/jbosscache-*"/>
         <include name="lib/hibernate-jbosscache2.jar"/>
+		<include name="lib/hibernate-ehcache.jar"/>
+		<include name="lib/hibernate-oscache.jar"/>
+		<include name="lib/hibernate-swarmcache.jar"/>
         <include name="lib/jgroups.jar"/>
       </fileset>
     </copy>
@@ -1063,6 +1069,9 @@
     <move todir="${install.common.lib}">
       <fileset dir="${install.all.lib}">
         <exclude name="hibernate-jbosscache2.jar"/>
+		<exclude name="hibernate-ehcache.jar"/>
+		<exclude name="hibernate-oscache.jar"/>
+		<exclude name="hibernate-swarmcache.jar"/>
         <exclude name="jacorb.jar"/>
         <exclude name="jbosscache-core.jar"/>
         <exclude name="jbosscache-pojo.jar"/>
@@ -1140,6 +1149,9 @@
         <include name="deploy/cluster/jboss-cache-manager.sar/**"/>
         <include name="lib/jbosscache-*"/>
         <include name="lib/hibernate-jbosscache2.jar"/>
+		<include name="lib/hibernate-ehcache.jar"/>
+		<include name="lib/hibernate-oscache.jar"/>
+		<include name="lib/hibernate-swarmcache.jar"/>
         <include name="lib/jgroups.jar"/>
         <exclude name="lib/bsf.jar"/>
         <exclude name="lib/bsh.jar"/>