Index: pom.xml
===================================================================
--- pom.xml	(revision 99951)
+++ pom.xml	(working copy)
@@ -116,32 +116,22 @@
                   <groupId>org.jboss.jbossas</groupId>
                   <artifactId>jboss-server-manager</artifactId>
                 </artifactItem>
-              </artifactItems>
-              <outputDirectory>${project.build.directory}/dependencies/lib</outputDirectory>
-              <overWriteIfNewer>true</overWriteIfNewer>
-              <stripVersion>true</stripVersion>
-            </configuration>
-          </execution>
-
-          <!-- Copy dependencies necessary of Test Clients -->
-          <execution>
-            <id>copy-core-dependencies</id>
-            <phase>process-resources</phase>
-            <goals>
-              <goal>copy-dependencies</goal>
-            </goals>
-            <configuration>
-              <artifactItems>
                 <artifactItem>
-                  <groupId>org.jboss.ejb3</groupId>
-                  <artifactId>jboss-ejb3-core</artifactId>
-                  <scope>test</scope>
+                  <groupId>apache-httpclient</groupId>
+                  <artifactId>commons-httpclient</artifactId>
                 </artifactItem>
+                <artifactItem>
+                  <groupId>commons-codec</groupId>
+                  <artifactId>commons-codec</artifactId>
+                </artifactItem>
+                <artifactItem>
+                  <groupId>junit</groupId>
+                  <artifactId>junit</artifactId>
+                </artifactItem>
               </artifactItems>
               <outputDirectory>${project.build.directory}/dependencies/lib</outputDirectory>
               <overWriteIfNewer>true</overWriteIfNewer>
               <stripVersion>true</stripVersion>
-              <!-- <excludeTransitive>true</excludeTransitive>  -->
             </configuration>
           </execution>
 
Index: build-test.xml
===================================================================
--- build-test.xml	(revision 99922)
+++ build-test.xml	(working copy)
@@ -91,18 +91,19 @@
   <property name="location.dependencies" value="${location.target}/dependencies"/>
   <property name="location.dependencies.unpacked" value="${location.dependencies}/unpacked"/>
   <property name="location.dependencies.unpacked.jboss-test:jboss.test" value="${location.dependencies.unpacked}/jboss-test"/>
-  <property name="location.dependencies.lib" value="${location.dependencies}/lib"/>
-	<property name="location.dependencies.lib.ejb3persistence" value="${location.dependencies.lib}/ejb3-persistence.jar"/>
-	<property name="location.dependencies.lib.jbosssx" value="${location.dependencies.lib}/jbosssx.jar"/>
-  <property name="location.dependencies.lib.hibernate:hibernate3" value="${location.dependencies.lib}/hibernate-core.jar"/>
-  <property name="location.dependencies.lib.jboss-test:jboss-test" value="${location.dependencies.lib}/jboss-test.jar"/>
-  <property name="location.dependencies.lib.org.jboss.jbossas:server-manager" value="${location.dependencies.lib}/jboss-server-manager.jar"/>
-  <property name="location.dependencies.lib.junit:junit" value="${location.dependencies.lib}/junit.jar"/>
-  <property name="location.dependencies.lib.hsqldb:hsqldb" value="${location.dependencies.lib}/hsqldb.jar"/>
+	
+	<!-- We only allow dependencies lib for the test harness (not runtime components, those must come from JBOSS_HOME --> 
+	<property name="location.dependencies.lib" value="${location.dependencies}/lib"/>
+	<property name="location.dependencies.lib.jboss-test:jboss-test" value="${location.dependencies.lib}/jboss-test.jar"/>
+	<property name="location.dependencies.lib.org.jboss.jbossas:server-manager" value="${location.dependencies.lib}/jboss-server-manager.jar"/>
   <property name="location.dependencies.lib.apache-httpclient:commons-httpclient" value="${location.dependencies.lib}/commons-httpclient.jar"/>
-  <property name="location.dependencies.lib.apache-codec:commons-codec" value="${location.dependencies.lib}/commons-codec.jar"/>
-  <property name="location.dependencies.lib.org.jboss.cache:jbosscache-core" value="${location.dependencies.lib}/jbosscache-core.jar"/>
-  <property name="location.dependencies.lib.org.jboss.jboss-deployers-core-spi" value="${location.dependencies.lib}/jboss-deployers-core-spi.jar"/>
+	<property name="location.dependencies.lib.junit:junit" value="${location.dependencies.lib}/junit.jar"/>
+	<property name="location.dependencies.lib.apache-codec:commons-codec" value="${location.dependencies.lib}/commons-codec.jar"/>
+  
+	<property name="location.lib" value="${jboss.dist}/lib"/>
+	<property name="location.common.lib" value="${jboss.dist}/common/lib"/>
+	<property name="location.server.all.lib" value="${jboss.dist}/server/all/lib"/>
+		
   <property name="location.client.lib" value="${jboss.dist}/client"/>
   <property name="location.client.lib.commons-logging" value="${location.client.lib}/commons-logging.jar"/>
   <property name="location.client.lib.jbossall" value="${location.client.lib}/jbossall-client.jar"/>
@@ -119,13 +120,20 @@
   <property name="location.client.lib.apache.log4j" value="${location.client.lib}/log4j.jar"/>
     
   <!-- EJB3 Internal Artifacts -->
-  <property name="artifact.ejb3.cache" value="${location.dependencies.lib}/jboss-ejb3-cache.jar"/>
-  <property name="artifact.ejb3.interceptors" value="${location.dependencies.lib}/jboss-ejb3-interceptors.jar"/>
-  <property name="artifact.ejb3.extapi" value="${location.dependencies.lib}/jboss-ejb3-ext-api.jar"/>
-  <property name="artifact.ejb3.extapiimpl" value="${location.dependencies.lib}/jboss-ejb3-ext-api-impl.jar"/>
-  <property name="artifact.ejb3.core" value="${location.dependencies.lib}/jboss-ejb3-core.jar"/>
-	<property name="artifact.ejb3.pool" value="${location.dependencies.lib}/jboss-ejb3-pool.jar"/>
-    
+  <property name="artifact.ejb3.cache" value="${location.common.lib}/jboss-ejb3-cache.jar"/>
+  <property name="artifact.ejb3.interceptors" value="${location.common.lib}/jboss-ejb3-interceptors.jar"/>
+  <property name="artifact.ejb3.extapi" value="${location.common.lib}/jboss-ejb3-ext-api.jar"/>
+  <property name="artifact.ejb3.extapiimpl" value="${location.common.lib}/jboss-ejb3-ext-api-impl.jar"/>
+  <property name="artifact.ejb3.core" value="${location.common.lib}/jboss-ejb3-core.jar"/>
+  	
+  <!-- Other AS Artifacts -->
+  <property name="artifact.ejb3persistence" value="${location.common.lib}/ejb3-persistence.jar"/>
+  <property name="artifact.hibernate:hibernate3" value="${location.common.lib}/hibernate-core.jar"/>
+	<property name="artifact.org.jboss.jboss-deployers-core-spi" value="${location.lib}/jboss-deployers-core-spi.jar"/>
+	<property name="artifact.org.jboss.cache:jbosscache-core" value="${location.server.all.lib}/jbosscache-core.jar"/>
+	<property name="artifact.hsqldb:hsqldb" value="${location.common.lib}/hsqldb.jar"/>
+	<property name="artifact.jbosssx" value="${location.common.lib}/jbosssx.jar"/>
+	
   <!-- Define the Path to Server Task Definitions, used by the JBoss Server Run targets -->
   <path id="server.taskdef.classpath">  
      <pathelement path="${location.dependencies.lib.jboss-test:jboss-test}"/>
@@ -358,9 +366,6 @@
 	
 	  <!-- EJB3 ExtApiImpl -->
 	  <pathelement path="${artifact.ejb3.extapiimpl}" />
-  	
-    <!-- EJB3 Pool -->
-    <pathelement path="${artifact.ejb3.pool}" />
     
   </path>
     
@@ -384,25 +389,25 @@
     <pathelement path="${location.dependencies.lib.jboss-test:jboss-test}" />
   	
     <!-- JBoss SX -->
-    <pathelement path="${location.dependencies.lib.jbosssx}" />
+    <pathelement path="${artifact.jbosssx}" />
   	
   	<!-- EJB3 Persistence -->
-  	<pathelement path="${location.dependencies.lib.ejb3persistence}" />
+  	<pathelement path="${artifact.ejb3persistence}" />
 	
 	  <!-- Hibernate -->
-	  <pathelement path="${location.dependencies.lib.hibernate:hibernate3}" />
+	  <pathelement path="${artifact.hibernate:hibernate3}" />
     
     <!-- JBoss Deployers SPI -->
-	  <pathelement path="${location.dependencies.lib.org.jboss.jboss-deployers-core-spi}" />
+	  <pathelement path="${artifact.org.jboss.jboss-deployers-core-spi}" />
     
     <!-- JBoss Cache Core -->
-    <pathelement path="${location.dependencies.lib.org.jboss.cache:jbosscache-core}" />
+    <pathelement path="${artifact.org.jboss.cache:jbosscache-core}" />
 
     <!-- JUnit -->
     <pathelement path="${location.dependencies.lib.junit:junit}" />
 
     <!-- HSQL DB -->
-    <pathelement path="${location.dependencies.lib.hsqldb:hsqldb}" />
+    <pathelement path="${artifact.hsqldb:hsqldb}" />
     
     <!-- Apache HttpClient -->
     <pathelement path="${location.dependencies.lib.apache-httpclient:commons-httpclient}" />